library paypal;

import 'dart:convert';

import 'package:http/http.dart' as http;

class AccessTokenModel {
  final String access_token;
  String invoices;

  AccessTokenModel({this.access_token, this.invoices});

  factory AccessTokenModel.fromJson(Map<String, dynamic> json) {
    return AccessTokenModel(
      access_token: json['access_token'],
    );
  }
}

/// Access token
class PayPal {  
  //get Access token from api
  Future<AccessTokenModel> getAccessToken() async {
    //header start
    //this is basic token auth with username and password from paypal
    String auth =
        'Basic QVdyNnJUb3BLWTg4T0xwSDJPcHphREFROEQ1cmlNblk2QVduOExVbzFnLTh4SzdybDlVZjY2eE1Zc1hhbjR2ZXNQR2pfSEJrNWVUNnY2VVo6RUlZNXI1UDAwUW41U3FFSlJvRzBkaWFLaDlBR1JJOHpNZm1NX1pab3R5aE5lcWo2QWRlaDFKcmdUNVJ2dnAyRTRnbEpibW9ORG9Way1RRzc=';
    String contentType = 'application/x-www-form-urlencoded';
    Map<String, String> header = {
      'authorization': auth,
      'content-type': contentType,
    };
    //header end

    //body or params for api
    Map<String, String> bodyType = {
      'grant_type': 'client_credentials',
    };

    //exec of post api
    final response = await http.post(
        'https://api.sandbox.paypal.com/v1/oauth2/token',
        headers: header,
        body: bodyType);

    //checking response
    if (response.statusCode == 200) {
      return AccessTokenModel.fromJson(json.decode(response.body));
    } else {
      // If that call was not successful, throw an error.
      throw Exception('Failed to receive access token.');
    }
  }
}
